; ****************************************************************************
;       TITLE: DBOX1.sc
;     SESSION: PAOLINI - Interface Issues in Paradox 4
;   COPYRIGHT: (c) 1993 - Dan Paolini - DataStar International
; DESCRIPTION: Example of Dialog Box calling a nested dialog box
;              Enhanced routines in script "DS4_UTIL"
; ****************************************************************************

PROC msAlertDialog.u(            ; Alert Siren in Idle Dialog Box
         type.a,                 ; EVENT or TRIGGER
         tag.a,                  ; Control element tag or null
         event.v,                ; DynArray of GetEvent, or control value
         element.a)              ; Checkbox label or null
Private  w
;Global  alert.n                 ; Alert Value from dBox (0 - 5)
;Global  onceflag.l              ; For non-continuous Alert (1, 2)
   IF NOT IsAssigned(onceflag.l) THEN
      onceflag.l = true
   ENDIF
   SWITCH
      CASE alert.n = 1 AND onceflag.l :
         Beep Sleep 50
         Beep Sleep 50
         Beep
         onceflag.l = false            ; Turns off subsequent Alerts
      CASE alert.n = 2 AND onceflag.l :
         Sound 770 150
         Sound 440 150
         Sound 770 150
         Sound 440 150
         Sound 770 150
         onceflag.l = false            ; Turns off subsequent Alerts
      CASE alert.n = 3  :
         Beep Sleep 50 Beep Sleep 300
      CASE alert.n = 4  :
         Sound 300 50 Sleep 100
         Sound 300 50 Sleep 100
         Sound 150 50 Sleep 100
         Sound 150 50 Sleep 100
         Sleep 200
      CASE alert.n = 5  :
         Sound 770 150
         Sound 440 150
      CASE alert.n = 86 and onceflag.l :
         FOR n1 From 4 To 0 Step -1
            FOR n2 From 11 To 0 Step -1
               Sound Int(Pow(2,n1+n2/12)*110) 5
            ENDFOR
         ENDFOR
         Sound 10 3000
         onceflag.l = false            ; Turns off subsequent Alerts
   ENDSWITCH
   Return
ENDPROC
; ---------------------------------------------------------------------------
PROC msConfirm.l(                ; Confirmation DialogBox
         message.a,              ; Message to display (< 70 chars)
         msgcolor.n,             ; Color for message (not DialogBox!)
         toprow.n,               ; Top Row (999 = Centered Vertically)
         leftcol.n,              ; Left Column (999 = Centered Horizontally)
         colors.y,               ; Dynarray of custom colors
         alert.n,                ; Sound level of Alert (0 - 4)
         oklabel.a,              ; Label of CONTINUE Pushbutton
         cxlabel.a,              ; Label of CANCEL Pushbutton
         confirm.l)              ; Should Confirm be default?
Private  width.n,                ; Width of Dialog Box
         a1, a2,                 ; Match variables
         n1, n2,                 ; Button length comparisons
         buttonlength.n,         ; Width of Pushbuttons
         button.l,               ; Value of selected Pushbutton
         onceflag.l              ; True = Non-continuous Alert
   SetCanvas DEFAULT
   IF NOT IsAssigned(g.colorsapp.y) THEN
      GetColors To g.colorsapp.y
   ENDIF
   IF Type(colors.y) = "DY" THEN       ; Must be a DynArray, or else ignore
      SetColors From colors.y          ;  to control dBox colors
   ENDIF

   IF Len(message.a) = 1 THEN
      message.a = msShortcuts.a(message.a)
   ENDIF

   IF NOT IsAssigned(g.sysinfo.y) THEN
      SysInfo to g.sysinfo.y
   ENDIF

   onceflag.l = alert.n < 3 OR alert.n > 50
   button.l = false
   message.a = " " + message.a + " "

   width.n = Max(Len(message.a) + 4,Len(oklabel.a) + Len(cxlabel.a) + 24)
   a1 = ""
   a2 = oklabel.a
   WHILE Match(a1+a2,"..~..",a1,a2)
   ENDWHILE

   n1 = Len(a1+a2)
   a1 = ""
   a2 = cxlabel.a
   WHILE Match(a1+a2,"..~..",a1,a2)
   ENDWHILE

   n2 = Len(a1+a2)
   buttonlength.n = Max(n1,n2)+4

   IF toprow.n = 999 THEN
      toprow.n = 7                     ; If screen has more rows, keep at top
   ENDIF

   IF leftcol.n = 999 THEN
      leftcol.n = Int((g.sysinfo.y["ScreenWidth"]-width.n)/2)
   ENDIF

   IF confirm.l THEN                   ; Confirm button is DEFAULT
      SHOWDIALOG "Press <Enter> to Confirm"
         Proc "msAlertDialog.u" IDLE
         @ toprow.n, leftcol.n  Height 7 Width width.n
         PaintCanvas Fill Format("w"+StrVal(width.n-4)+",ac",message.a)
                     Attribute msgcolor.n  1, 1, 1, width.n - 4
         PushButton  @ 3,5
            Width buttonlength.n oklabel.a
            OK DEFAULT Value true Tag "OK"
         To button.l
         PushButton  @ 3,width.n-buttonlength.n-7
            Width buttonlength.n cxlabel.a
            CANCEL Value false Tag "Cancel"
         To button.l
      ENDDIALOG
   ELSE                                ; Cancel button is DEFAULT
      SHOWDIALOG "Press <Enter> to Cancel"
         Proc "msAlertDialog.u" IDLE
         @ toprow.n, leftcol.n  Height 7 Width width.n
         PaintCanvas Fill Format("w"+StrVal(width.n-4)+",ac",message.a)
                     Attribute msgcolor.n  1, 1, 1, width.n - 4
         PushButton  @ 3,5
            Width buttonlength.n cxlabel.a
            CANCEL DEFAULT Value false Tag "Cancel"
         To button.l
         PushButton  @ 3,width.n-buttonlength.n-7
            Width buttonlength.n oklabel.a
            OK Value true Tag "OK"
         To button.l
      ENDDIALOG
   ENDIF
   SetColors From g.colorsapp.y
   Return button.l
ENDPROC
; ---------------------------------------------------------------------------
PROC msContinue.u(               ; Generic Continue DialogBox
         message.a,              ; Message to display
         msgcolor.n,             ; Color for Message (not DialogBox!)
         toprow.n,               ; Top Row (999 = Centered Vertically)
         leftcol.n,              ; Left Column (999 = Centered Horizontally)
         colors.y,               ; Dynarray of custom colors
         alert.n)                ; Sound level of Alert (0 - 5)
Private  width.n,                ; Width of Dialog Box
         button.a,               ; Value of selected Pushbutton
         onceflag.l              ; True = non-continuous alert
;Global  g.colorsapp.y           ; Global application colors
   SetCanvas DEFAULT
   IF NOT IsAssigned(g.colorsapp.y) THEN
      GetColors To g.colorsapp.y
   ENDIF
   IF Type(colors.y) = "DY" THEN    ; Must be a DynArray, or else ignore
      SetColors From colors.y
   ENDIF

   IF Len(message.a) = 1 THEN
      message.a = msShortcuts.a(message.a)
   ENDIF

   IF NOT IsAssigned(g.sysinfo.y) THEN
      SysInfo to g.sysinfo.y
   ENDIF

   onceflag.l = alert.n < 3 OR alert.n > 50
   message.a = " " + message.a + " "
   width.n = Max(Len(message.a) + 4, 35)

   IF toprow.n = 999 THEN
      toprow.n = 7                     ; If screen has more rows, keep at top
   ENDIF

   IF leftcol.n = 999 THEN
      leftcol.n = Int((g.sysinfo.y["ScreenWidth"]-width.n)/2)
   ENDIF

   SHOWDIALOG "Press <Enter> to Continue"
      Proc "msAlertDialog.u" Idle     ; Wait for Key Alert
      @ toprow.n,leftcol.n
      Height 7 Width width.n

      PaintCanvas Fill Format("w"+StrVal(width.n-4)+",ac",message.a)
                  Attribute msgcolor.n  1, 1, 1, width.n - 4

      PushButton @ 3,Int(width.n/2)-7
         Width 12 "~C~ontinue"
         OK Default Value msConfirm.l("Do You See Possibilities?",
                                       113, 12, 999, "", 2,
                                      "~S~ure!", "~H~unh?", true)
         Tag "OK"
      To button.l
   ENDDIALOG
   SetColors From g.colorsapp.y
   Return
ENDPROC

msContinue.u("Press <Continue> to Call Another Dialog Box",
              116, 999, 999, "", 1)
Release VARS ALL
